// 217_1.cpp:   .

#include "stdafx.h"
#include <stdio.h>

using namespace System;
using namespace System::Runtime::InteropServices;

// unmanaged struct 
struct ListStruct
{
	int count; 
	double* item;
};
#pragma unmanaged
void UnmanagedTakesListStruct(ListStruct list)
{
	printf_s("[unmanaged] count = %d\n", list.count); 
	for (int i = 0; i < list.count; i++)
		printf_s("array[%d] = %.2f\n", i, list.item[i]);
}
#pragma managed

void main()
{
	ListStruct list; 
	list.count = 10; 
	list.item = new double[list.count];
	//  new    native-
	//      .
	//        
	//   list.count .

	Console::WriteLine("[managed] count = {0}", list.count); 
	//    ,  
	//  : 
	Random^ r = gcnew Random(0);

	//   list.item[]  
	//    [0,1],   100
	for (int i = 0; i < list.count; i++)
	{
		list.item[i] = r->NextDouble() * 100.0;
		Console::WriteLine("array[{0}] = {1}", i, list.item[i]);
	}
	//  native-  managed- 
	UnmanagedTakesListStruct(list); 
	Console::ReadLine();
}
